## hddemux 0.2

=== Makefile ===
CFLAGS += -D_GNU_SOURCE -g -O3

CFLAGS += $(shell pkg-config --cflags libuv)
CFLAGS += $(shell pkg-config --cflags libsystemd)
LDFLAGS += $(shell pkg-config --libs libuv)
LDFLAGS += $(shell pkg-config --libs libsystemd)

all: hddemux hddemux.1

hddemux: hddemux.c
	gcc $(CFLAGS) $(LDFLAGS) -std=c11 -pedantic -Wall -Werror -o $@ $<

hddemux.1: hddemux.1.md
	pandoc -s -f markdown -t man -o $@ $<

draft-dkg-dprive-demux-dns-http.xml: draft-dkg-dprive-demux-dns-http.md
	kramdown-rfc2629 < $< > $@

draft-dkg-dprive-demux-dns-http.html: draft-dkg-dprive-demux-dns-http.xml
	xml2rfc $< --html

draft-dkg-dprive-demux-dns-http.txt: draft-dkg-dprive-demux-dns-http.xml
	xml2rfc $< --text

clean:
	rm -f hddemux hddemux.1 \
	.refcache/ \
	draft-dkg-dprive-demux-dns-http.txt \
	draft-dkg-dprive-demux-dns-http.html \
	draft-dkg-dprive-demux-dns-http.xml

.PHONY: clean all

## hddemux 0.3

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	xml2rfc $< --text
 
 clean:
-	rm -f hddemux hddemux.1 \
+	rm -rf hddemux hddemux.1 \
 	.refcache/ \
 	draft-dkg-dprive-demux-dns-http.txt \
 	draft-dkg-dprive-demux-dns-http.html \

=== debian/changelog ===
hddemux (0.3-1ubuntu1) artful; urgency=medium

  * debian/patches/compiler-flags.patch: pass correct compiler flags.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 15 Aug 2017 03:55:00 +0000

hddemux (0.3-1) unstable; urgency=medium

  * new upstream release
  * focus on HTTP/1.x, since HTTP/2 is not client-speaks-first

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 17 May 2017 12:46:35 -0400

hddemux (0.2-2) unstable; urgency=medium

  * Build-Depend on pkg-config (Closes: #861246)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 26 Apr 2017 23:43:26 -0700

hddemux (0.2-1) unstable; urgency=medium

  * New upstream version
   - minor service cleanup

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 24 Apr 2017 21:01:42 -0400

hddemux (0.1-1) unstable; urgency=medium

  * Debian packaging (Closes: #861143)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 24 Apr 2017 21:01:42 -0400

=== debian/control ===
Source: hddemux
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper (>= 10~),
 libsystemd-dev,
 libuv1-dev,
 pandoc,
 pkg-config,
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/hddemux -b debian
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hddemux
Homepage: https://0xacab.org/dkg/hddemux

Package: hddemux
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Description: HTTP/1.x and DNS demultiplexer
 hddemux listens on a stream and routes incoming clients to either an
 HTTP/1.x backend or a DNS stream-based backend depending on the first
 request to appear on the stream.
 .
 This is useful when making DNS-over-TLS (RFC 7858) connections that
 appear to the network be HTTPS connections, for example, which makes
 it easier to traverse a network that would prefer to block the user
 from making DNS-over-TLS queries.

## hddemux 0.4

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+#!/usr/bin/make -f
+
 CFLAGS += -D_GNU_SOURCE -g -O3
 
 CFLAGS += $(shell pkg-config --cflags libuv)
@@ -7,8 +9,11 @@
 
 all: hddemux hddemux.1
 
+check: hddemux
+	PATH=.:$$PATH ./testsuite
+
 hddemux: hddemux.c
-	gcc $(CFLAGS) $(LDFLAGS) -std=c11 -pedantic -Wall -Werror -o $@ $<
+	gcc $(CPPFLAGS) $(CFLAGS) $< $(LDFLAGS) -std=c11 -pedantic -Wall -Werror -o $@
 
 hddemux.1: hddemux.1.md
 	pandoc -s -f markdown -t man -o $@ $<
@@ -29,4 +34,4 @@
 	draft-dkg-dprive-demux-dns-http.html \
 	draft-dkg-dprive-demux-dns-http.xml
 
-.PHONY: clean all
+.PHONY: clean all check

=== debian/changelog ===
hddemux (0.4-7ubuntu1) disco; urgency=medium

  * testsuite: Avoid failure when https_proxy is set

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 07 Jan 2019 17:18:50 +0100

hddemux (0.4-7) unstable; urgency=medium

  [ Steve Langasek ]
  * Avoid test suite on s390x (Closes: #908138)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 11 Sep 2018 23:50:01 -0400

hddemux (0.4-6) unstable; urgency=medium

  * disable testing on arm64 platform due to #907729

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Sep 2018 19:55:28 -0400

hddemux (0.4-5) unstable; urgency=medium

  * autopkgtest: avoid leaking stderr on deliberate failure

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 31 Aug 2018 09:27:38 -0400

hddemux (0.4-4) unstable; urgency=medium

  * still more nginx cleanup in the testsuite

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Aug 2018 11:44:07 -0400

hddemux (0.4-3) unstable; urgency=medium

  * more testsuite fixes

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Aug 2018 10:09:42 -0400

hddemux (0.4-2) unstable; urgency=medium

  * make the test suite a little more robust and verbose

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Aug 2018 09:26:03 -0400

hddemux (0.4-1) unstable; urgency=medium

  * new upstream release
   - Closes: #906471, #872188
   - yes, i can actually count to 16 in hex
   - added a simple, totally incomplete test suite
   - fix makefile for --Wl,--as-needed (addresses)
   - actually verify whether the loop closes correctly
   - use UV_* symbols instead of libuv-internal UV__*
   - add real test suite
  * move to dh 11
  * Standards-Version: bump to 4.2.1 (no changes needed)
  * use Rules-Requires-Root: no
  * move to salsa
  * use DEP-14 branch naming
  * add autopkgtest
  * handle upstream test suite

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Aug 2018 09:25:34 -0400

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,22 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
- debhelper (>= 10~),
+ curl [!arm64] <!nocheck>,
+ debhelper (>= 11~),
+ gnutls-bin [!arm64] <!nocheck>,
+ knot-dnsutils [!arm64] <!nocheck>,
+ knot-resolver [!arm64 !s390x] <!nocheck>,
  libsystemd-dev,
  libuv1-dev,
+ nginx-light [!arm64] <!nocheck>,
  pandoc,
  pkg-config,
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/hddemux -b debian
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/hddemux
+ systemd [!arm64] <!nocheck>,
+Standards-Version: 4.2.1
+Vcs-Git: https://salsa.debian.org/debian/hddemux.git -b debian/master
+Vcs-Browser: https://salsa.debian.org/debian/hddemux
 Homepage: https://0xacab.org/dkg/hddemux
+Rules-Requires-Root: no
 
 Package: hddemux
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

KRESD_BROKEN_ARCHES := arm64 s390x
ifneq (, $(filter $(DEB_HOST_ARCH), $(KRESD_BROKEN_ARCHES)))
  DEB_BUILD_OPTIONS += nocheck
endif

%:
	dh $@

## hddemux 0.5

=== Makefile ===
--- 
+++ 
@@ -2,10 +2,11 @@
 
 CFLAGS += -D_GNU_SOURCE -g -O3
 
-CFLAGS += $(shell pkg-config --cflags libuv)
-CFLAGS += $(shell pkg-config --cflags libsystemd)
-LDFLAGS += $(shell pkg-config --libs libuv)
-LDFLAGS += $(shell pkg-config --libs libsystemd)
+PKG_CONFIG ?= pkg-config
+CFLAGS += $(shell $(PKG_CONFIG) --cflags libuv)
+CFLAGS += $(shell $(PKG_CONFIG) --cflags libsystemd)
+LDFLAGS += $(shell $(PKG_CONFIG) --libs libuv)
+LDFLAGS += $(shell $(PKG_CONFIG) --libs libsystemd)
 
 all: hddemux hddemux.1
 
@@ -13,7 +14,7 @@
 	PATH=.:$$PATH ./testsuite
 
 hddemux: hddemux.c
-	gcc $(CPPFLAGS) $(CFLAGS) $< $(LDFLAGS) -std=c11 -pedantic -Wall -Werror -o $@
+	$(CC) $(CPPFLAGS) $(CFLAGS) $< -Wl,--as-needed $(LDFLAGS) -std=c11 -pedantic -Wall -Werror -o $@
 
 hddemux.1: hddemux.1.md
 	pandoc -s -f markdown -t man -o $@ $<

=== debian/changelog ===
hddemux (0.5-1ubuntu4) resolute; urgency=medium

  * Update build and test dependency to knot-resolver6.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 16 Nov 2025 04:25:34 +0000

hddemux (0.5-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:05:03 +1100

hddemux (0.5-1ubuntu2) noble; urgency=high

  * No change rebuild against libuv1t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:24:44 +0100

hddemux (0.5-1ubuntu1) kinetic; urgency=medium

  * Fix ppc64el FTBFS due to changes to knot-resolver (LP: #1984134)

 -- Dan Bungert <daniel.bungert@canonical.com>  Tue, 09 Aug 2022 12:54:59 -0600

hddemux (0.5-1) unstable; urgency=medium

  * new upstream version (all patches merged)
   - enable cross-building (Closes: #928996)
   - unset https_proxy during test suite (Closes: #918608)
   - stop trying to use socket-activation for kresd
     in test suite (Closes: #964055)
  * Update standards version to 4.6.0, no changes needed.
  * Set debhelper-compat version in Build-Depends.
  * Re-export upstream signing key without extra signatures.
  * Set upstream metadata fields: Repository.
  * move to dh 13

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 31 Jan 2022 12:56:12 -0500

hddemux (0.4-8) unstable; urgency=medium

  [ Julian Andres Klode ]
  * avoid testsuite failure when https_proxy is set (Closes: #918608)

  [ Daniel Kahn Gillmor ]
  * move to debhelper 12
  * standards-version: bump to 4.3.0 (no changes needed)
  * link only as needed

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 07 Jan 2019 16:37:07 -0500

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,18 @@
 XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
  curl [!arm64] <!nocheck>,
- debhelper (>= 11~),
+ debhelper-compat (= 13),
  gnutls-bin [!arm64] <!nocheck>,
  knot-dnsutils [!arm64] <!nocheck>,
- knot-resolver [!arm64 !s390x] <!nocheck>,
+ knot-resolver6 [!arm64 !ppc64el !s390x] <!nocheck>,
  libsystemd-dev,
  libuv1-dev,
  nginx-light [!arm64] <!nocheck>,
  pandoc,
  pkg-config,
  systemd [!arm64] <!nocheck>,
-Standards-Version: 4.2.1
-Vcs-Git: https://salsa.debian.org/debian/hddemux.git -b debian/master
+Standards-Version: 4.6.0
+Vcs-Git: https://salsa.debian.org/debian/hddemux.git -b debian/main
 Vcs-Browser: https://salsa.debian.org/debian/hddemux
 Homepage: https://0xacab.org/dkg/hddemux
 Rules-Requires-Root: no

=== debian/tests/control ===
Test-Command: WORKDIR=$AUTOPKGTEST_ARTIFACTS ./testsuite
Depends: knot-resolver6, knot-dnsutils, nginx-light, curl, gnutls-bin, systemd, @
Restrictions: skip-not-installable

=== debian/watch ===
version=4
 https://0xacab.org/dkg/hddemux/tags .*/hddemux-hddemux-([\d.]*)\.tar\.gz
